**************************************************************************
*
* MsgBox (Proclip only version)
*
* By David A. Richardson [72271,53]
* Copyright (C) 1990 David A. Richardson
*
* This functions is free.  Modify and use them as you like. 
*
* Date:    January 14, 1990
* Syntax:  msgbox(str, str, str, auto, get, beep)     
* Returns: The saved screen area (string), or a logical based on
*          the users response to a YN prompt, or .t.
*          (See README.MSG) 
*
**************************************************************************

function MsgBox
parameters msg1, msg2, msg3, action, beep, boxt

private i, boxl, boxh, boxt, boxoff, ocolor, ok, rval, nargs, ;
        nomsg2, nomsg3, lmsg1, lmsg2, lmsg3, maxl, obox, ocurs
        

*
* Initilaize the defaults
*
          
nargs=  pcount()
ocurs= savecurs()
ocolor= setcolor( clr_msgbox )
nomsg2= .t.
nomsg3= .t.
ok=     " "
rval=   .t.
boxh=   4
mget=   .f.
pause=  .f.
lmsg1=  len( msg1 )
lmsg2=  0 
lmsg3=  0

*
* Check the parameters
*

if nargs < 6
   boxt= -1
endif

if nargs < 5
   beep= 0
endif

if nargs < 4 
   action= ""
endif

if nargs < 3
   msg3= ""
else 
   lmsg3= len( msg3 )
   if lmsg3 > 0
      nomsg3= .f.
      boxh= boxh + 2
   endif
endif

if nargs < 2 
   msg2= ""
else
   lmsg2= len( msg2 )
   if lmsg2 > 0
      nomsg2= .f.
      boxh= boxh + 2
   endif
endif

*
* The following can be handled in two lines if you're
* willing to use macros
*

if action= "g"

   if !nomsg3
      lmsg3= lmsg3 + 6
   elseif !nomsg2
      lmsg2= lmsg2 + 6
   else
      lmsg1= lmsg1 + 6
   endif

endif

*
* Set the sizes
*

maxl= max( max( lmsg1, lmsg2 ), lmsg3 )
boxl= if( maxl < 8, 15, maxl + 6 )

if action == "p"
   boxh= boxh + 1
   boxl= max( boxl, 32 )
endif

boxt= if( boxt < 0,( 25 - boxh ) /2, boxt )
boxoff= ( 80 - boxl ) /2 

obox= savebox( boxt, boxoff, boxt + boxh +1, boxoff + boxl +2 )


*
* Print the box and text to the screen
*

newcolor( boxT + 1, boxoff +2, boxt + boxh + 1, boxoff + boxl +2, clr_shadow )
@ boxt, boxoff, boxt + boxh, boxoff + boxl box boxframe

set color to ( clr_msgtxt )
@ boxt + 2, boxoff + ( boxl-lmsg1 ) /2 say msg1

if !nomsg2
   @ boxt + 4, boxoff + ( boxl-lmsg2 ) /2 say msg2
endif

if !nomsg3
   @ boxt + 6, boxoff + ( boxl-lmsg3 ) /2 say msg3
endif

@ boxt + boxh-2, col() say if(action == "g", "(Y,N) ", "")

*
* Do the rest
*
for i= 1 to beep
   tone( 1000, 1 )
next

if action == "g" 

   cursor("on") 
   do while !ok $ "YN"

      if !rval
         tone( 250, 1 )
      endif

      ok= upper( chr( inkey( 0 )))

      rval= ( ok == "Y" )

   enddo
   cursor( "off" )
   restbox( obox )

elseif action == "p"

   set color to ( "*" + clr_msgtxt )
   @ boxt + boxh -1, boxoff + 2 say "Press any key..."
   clear typeahead
   inkey( 0 )
   restbox( obox )

else 

   rval= obox

endif

set color to ( ocolor )
cursor( ocurs ) 
return rval

*** eof msgBox ***

